gtkmm: Gtk::EntryCompletion Class Reference

gtkmm 4.6.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gtk::EntryCompletion Class Reference

Completion functionality for Gtk::Entry. More...

`#include <gtkmm/entrycompletion.h>`

Inheritance diagram for Gtk::EntryCompletion:
[legend]

## Public Types
typedef sigc::slot< bool(const Glib::ustring &, const TreeModel::const_iterator &)> | SlotMatch
| For example, bool on_match(const Glib::ustring& key, const TreeModel::const_iterator& iter);. More...
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from Gtk::CellLayout
typedef sigc::slot< void(const TreeModel::const_iterator &)> | SlotCellData

## Public Member Functions
| EntryCompletion (EntryCompletion && src) noexcept
EntryCompletion & | operator= (EntryCompletion && src) noexcept
| ~EntryCompletion () noexcept override
GtkEntryCompletion * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkEntryCompletion * | gobj () const
| Provides access to the underlying C GObject. More...
GtkEntryCompletion * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Entry * | get_entry ()
| Gets the entry completion has been attached to. More...
const Entry * | get_entry () const
| Gets the entry completion has been attached to. More...
void | set_model (const Glib::RefPtr< TreeModel > & model)
| Sets the model for a Gtk::EntryCompletion. More...
Glib::RefPtr< TreeModel > | get_model ()
| Returns the model the `Gtk::EntryCompletion` is using as data source. More...
Glib::RefPtr< const TreeModel > | get_model () const
| Returns the model the `Gtk::EntryCompletion` is using as data source. More...
void | unset_model ()
| Remove the model from the EntryCompletion. More...
void | set_match_func (const SlotMatch & slot)
void | set_minimum_key_length (int length)
| Requires the length of the search key for completion to be at least length. More...
int | get_minimum_key_length () const
| Returns the minimum key length as set for completion. More...
Glib::ustring | compute_prefix (const Glib::ustring & key)
| Computes the common prefix that is shared by all rows in completion that start with key. More...
void | complete ()
| Requests a completion operation, or in other words a refiltering of the current list with completions, using the current key. More...
void | insert_prefix ()
| Requests a prefix insertion. More...
void | set_inline_completion (bool inline_completion=true)
| Sets whether the common prefix of the possible completions should be automatically inserted in the entry. More...
bool | get_inline_completion () const
| Returns whether the common prefix of the possible completions should be automatically inserted in the entry. More...
void | set_inline_selection (bool inline_selection=true)
| Sets whether it is possible to cycle through the possible completions inside the entry. More...
bool | get_inline_selection () const
| Returns `true` if inline-selection mode is turned on. More...
void | set_popup_completion (bool popup_completion=true)
| Sets whether the completions should be presented in a popup window. More...
bool | get_popup_completion () const
| Returns whether the completions should be presented in a popup window. More...
void | set_popup_set_width (bool popup_set_width=true)
| Sets whether the completion popup window will be resized to be the same width as the entry. More...
bool | get_popup_set_width () const
| Returns whether the completion popup window will be resized to the width of the entry. More...
void | set_popup_single_match (bool popup_single_match=true)
| Sets whether the completion popup window will appear even if there is only a single match. More...
bool | get_popup_single_match () const
| Returns whether the completion popup window will appear even if there is only a single match. More...
Glib::ustring | get_completion_prefix () const
| Get the original text entered by the user that triggered the completion or an empty string if there's no completion ongoing. More...
void | set_text_column (const TreeModelColumnBase & column)
| Convenience function for setting up the most used case of this code: a completion list with just strings. More...
void | set_text_column (int column)
| Convenience function for setting up the most used case of this code: a completion list with just strings. More...
int | get_text_column () const
| Returns the column in the model of completion to get strings from. More...
Glib::SignalProxy< bool(const TreeModel::iterator &)> | signal_match_selected ()
| Emitted when a match from the list is selected. More...
Glib::SignalProxy< bool(const TreeModel::iterator &)> | signal_cursor_on_match ()
| Emitted when a match from the cursor is on a match of the list. More...
Glib::SignalProxy< bool(const Glib::ustring &)> | signal_insert_prefix ()
Glib::SignalProxy< void()> | signal_no_matches ()
Glib::PropertyProxy< Glib::RefPtr< Gtk::TreeModel > > | property_model ()
| The model to find matches in. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gtk::TreeModel > > | property_model () const
| The model to find matches in. More...
Glib::PropertyProxy< int > | property_minimum_key_length ()
| Minimum length of the search key in order to look up matches. More...
Glib::PropertyProxy_ReadOnly< int > | property_minimum_key_length () const
| Minimum length of the search key in order to look up matches. More...
Glib::PropertyProxy< int > | property_text_column ()
| The column of the model containing the strings. More...
Glib::PropertyProxy_ReadOnly< int > | property_text_column () const
| The column of the model containing the strings. More...
Glib::PropertyProxy< bool > | property_inline_completion ()
| Determines whether the common prefix of the possible completions should be inserted automatically in the entry. More...
Glib::PropertyProxy_ReadOnly< bool > | property_inline_completion () const
| Determines whether the common prefix of the possible completions should be inserted automatically in the entry. More...
Glib::PropertyProxy< bool > | property_popup_completion ()
| Determines whether the possible completions should be shown in a popup window. More...
Glib::PropertyProxy_ReadOnly< bool > | property_popup_completion () const
| Determines whether the possible completions should be shown in a popup window. More...
Glib::PropertyProxy< bool > | property_popup_set_width ()
| Determines whether the completions popup window will be resized to the width of the entry. More...
Glib::PropertyProxy_ReadOnly< bool > | property_popup_set_width () const
| Determines whether the completions popup window will be resized to the width of the entry. More...
Glib::PropertyProxy< bool > | property_popup_single_match ()
| Determines whether the completions popup window will shown for a single possible completion. More...
Glib::PropertyProxy_ReadOnly< bool > | property_popup_single_match () const
| Determines whether the completions popup window will shown for a single possible completion. More...
Glib::PropertyProxy< bool > | property_inline_selection ()
| Determines whether the possible completions on the popup will appear in the entry as you navigate through them. More...
Glib::PropertyProxy_ReadOnly< bool > | property_inline_selection () const
| Determines whether the possible completions on the popup will appear in the entry as you navigate through them. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< CellArea > > | property_cell_area () const
| The `Gtk::CellArea` used to layout cell renderers in the treeview column. More...
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from Gtk::CellLayout
| CellLayout (CellLayout && src) noexcept
CellLayout & | operator= (CellLayout && src) noexcept
| ~CellLayout () noexcept override
GtkCellLayout * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkCellLayout * | gobj () const
| Provides access to the underlying C GObject. More...
template<class ColumnType >
void | pack_start (const TreeModelColumn< ColumnType > & model_column, bool expand=true)
void | pack_start (CellRenderer & cell, bool expand=true)
| Packs the cell into the beginning of cell_layout. More...
void | pack_end (CellRenderer & cell, bool expand=true)
| Adds the cell to the end of cell_layout. More...
std::vector< CellRenderer * > | get_cells ()
| Returns the cell renderers which have been added to cell_layout. More...
std::vector< const CellRenderer * > | get_cells () const
| Returns the cell renderers which have been added to cell_layout. More...
CellRenderer * | get_first_cell ()
| Gets the CellRenderer for the first column if any has been added, or nullptr otherwise. More...
const CellRenderer * | get_first_cell () const
| Gets the CellRenderer for the first column if any has been added, or nullptr otherwise. More...
void | clear ()
| Unsets all the mappings on all renderers on cell_layout and removes all renderers from cell_layout. More...
void | add_attribute (CellRenderer & cell, const Glib::ustring & attribute, int column)
| Adds an attribute mapping to the list in cell_layout. More...
void | add_attribute (const Glib::PropertyProxy_Base & property, const TreeModelColumnBase & column)
void | add_attribute (CellRenderer & cell, const Glib::ustring & attribute, const TreeModelColumnBase & column)
void | set_cell_data_func (CellRenderer & cell, const SlotCellData & slot)
void | clear_attributes (CellRenderer & cell)
| Clears all existing attributes previously set with set_attributes(). More...
void | reorder (CellRenderer & cell, int position)
| Re-inserts cell at position. More...
Glib::RefPtr< CellArea > | get_area ()
| Returns the underlying `Gtk::CellArea` which might be cell_layout if called on a `Gtk::CellArea` or might be `nullptr` if no `Gtk::CellArea` is used by cell_layout. More...
Glib::RefPtr< const CellArea > | get_area () const
| Returns the underlying `Gtk::CellArea` which might be cell_layout if called on a `Gtk::CellArea` or might be `nullptr` if no `Gtk::CellArea` is used by cell_layout. More...
template<class T_ModelColumnType >
void | pack_start (const TreeModelColumn< T_ModelColumnType > & column, bool expand)
Public Member Functions inherited from Glib::Interface
| Interface ()
| Interface (Interface &&src) noexcept
Interface & | operator= (Interface &&src) noexcept
| Interface (const Glib::Interface_Class &interface_class)
| Interface (GObject *castitem)
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const
Public Member Functions inherited from Gtk::Buildable
| Buildable (Buildable && src) noexcept
Buildable & | operator= (Buildable && src) noexcept
| ~Buildable () noexcept override
GtkBuildable * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkBuildable * | gobj () const
| Provides access to the underlying C GObject. More...
Glib::ustring | get_buildable_id () const
| Gets the ID of the buildable object. More...

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< EntryCompletion > | create ()
Static Public Member Functions inherited from Gtk::CellLayout
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gtk::Buildable
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions
| EntryCompletion ()
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)
Protected Member Functions inherited from Gtk::CellLayout
| CellLayout ()
| You should derive from this class to use it. More...
virtual void | pack_start_vfunc (CellRenderer * cell, bool expand)
virtual void | pack_end_vfunc (CellRenderer * cell, bool expand)
virtual void | clear_vfunc ()
virtual void | add_attribute_vfunc (CellRenderer * cell, const Glib::ustring & attribute, int column)
virtual void | clear_attributes_vfunc (CellRenderer * cell)
virtual void | reorder_vfunc (CellRenderer * cell, int position)
Protected Member Functions inherited from Gtk::Buildable
| Buildable ()
| You should derive from this class to use it. More...

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gtk::EntryCompletion > | wrap (GtkEntryCompletion * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::CellLayout
Glib::RefPtr< Gtk::CellLayout > | wrap (GtkCellLayout * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Buildable
Glib::RefPtr< Gtk::Buildable > | wrap (GtkBuildable * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Detailed Description

Completion functionality for Gtk::Entry.

Gtk::EntryCompletion is an auxiliary object to be used in conjunction with Gtk::Entry to provide the completion functionality.

It derives from Gtk::CellLayout, to allow the user to add extra cells to the Gtk::TreeView with completion matches.

"Completion functionality" means that when the user modifies the text in the entry, Gtk::EntryCompletion checks which rows in the model match the current content of the entry, and displays a list of matches. By default, the matching is done by comparing the entry text case-insensitively against the text column of the model (see set_text_column()), but this can be overridden with a custom match function (see set_match_func()).

When the user selects a completion, the content of the entry is updated. By default, the content of the entry is replaced by the text column of the model, but this can be overridden by connecting to the match_selected signal and updating the entry in the signal handler. Note that you should return true from the signal handler to suppress the default behaviour.

To add completion functionality to an entry, use Gtk::Entry::set_completion().

## Member Typedef Documentation

## ◆ SlotMatch

typedef sigc::slot<bool(const Glib::ustring&, const TreeModel::const_iterator&)> Gtk::EntryCompletion::SlotMatch

For example, bool on_match(const Glib::ustring& key, const TreeModel::const_iterator& iter);.

## Constructor & Destructor Documentation

## ◆ EntryCompletion() [1/2]

Gtk::EntryCompletion::EntryCompletion | ( | EntryCompletion && | src | ) |
| noexcept

## ◆ ~EntryCompletion()

Gtk::EntryCompletion::~EntryCompletion | ( |  | ) |
| overridenoexcept

## ◆ EntryCompletion() [2/2]

Gtk::EntryCompletion::EntryCompletion | ( |  | ) |
| protected

## Member Function Documentation

## ◆ complete()

void Gtk::EntryCompletion::complete | ( |  | ) |

Requests a completion operation, or in other words a refiltering of the current list with completions, using the current key.

The completion list view will be updated accordingly.

## ◆ compute_prefix()

Glib::ustring Gtk::EntryCompletion::compute_prefix | ( | const Glib::ustring & | key | ) |

Computes the common prefix that is shared by all rows in completion that start with key.

If no row matches key, `nullptr` will be returned. Note that a text column must have been set for this function to work, see set_text_column() for details.

Parameters

  key | The text to complete for.

Returns
  The common prefix all rows starting with key.

## ◆ create()

static Glib::RefPtr< EntryCompletion > Gtk::EntryCompletion::create | ( |  | ) |
| static

## ◆ get_completion_prefix()

Glib::ustring Gtk::EntryCompletion::get_completion_prefix | ( |  | ) | const

Get the original text entered by the user that triggered the completion or an empty string if there's no completion ongoing.

Since gtkmm 2.12:

Returns
  The prefix for the current completion.

## ◆ get_entry() [1/2]

Entry * Gtk::EntryCompletion::get_entry | ( |  | ) |

Gets the entry completion has been attached to.

Returns
  The entry completion has been attached to.

## ◆ get_entry() [2/2]

const Entry * Gtk::EntryCompletion::get_entry | ( |  | ) | const

Gets the entry completion has been attached to.

Returns
  The entry completion has been attached to.

## ◆ get_inline_completion()

bool Gtk::EntryCompletion::get_inline_completion | ( |  | ) | const

Returns whether the common prefix of the possible completions should be automatically inserted in the entry.

Returns
  `true` if inline completion is turned on.

## ◆ get_inline_selection()

bool Gtk::EntryCompletion::get_inline_selection | ( |  | ) | const

Returns `true` if inline-selection mode is turned on.

Returns
  `true` if inline-selection mode is on.

## ◆ get_minimum_key_length()

int Gtk::EntryCompletion::get_minimum_key_length | ( |  | ) | const

Returns the minimum key length as set for completion.

Returns
  The currently used minimum key length.

## ◆ get_model() [1/2]

Glib::RefPtr< TreeModel > Gtk::EntryCompletion::get_model | ( |  | ) |

Returns the model the `Gtk::EntryCompletion` is using as data source.

Returns
  A `Gtk::TreeModel`.

## ◆ get_model() [2/2]

Glib::RefPtr< const TreeModel > Gtk::EntryCompletion::get_model | ( |  | ) | const

Returns the model the `Gtk::EntryCompletion` is using as data source.

Returns
  A `Gtk::TreeModel`.

## ◆ get_popup_completion()

bool Gtk::EntryCompletion::get_popup_completion | ( |  | ) | const

Returns whether the completions should be presented in a popup window.

Returns
  `true` if popup completion is turned on.

## ◆ get_popup_set_width()

bool Gtk::EntryCompletion::get_popup_set_width | ( |  | ) | const

Returns whether the completion popup window will be resized to the width of the entry.

Returns
  `true` if the popup window will be resized to the width of the entry.

## ◆ get_popup_single_match()

bool Gtk::EntryCompletion::get_popup_single_match | ( |  | ) | const

Returns whether the completion popup window will appear even if there is only a single match.

Returns
  `true` if the popup window will appear regardless of the number of matches.

## ◆ get_text_column()

int Gtk::EntryCompletion::get_text_column | ( |  | ) | const

Returns the column in the model of completion to get strings from.

Returns
  The column containing the strings.

## ◆ get_type()

static GType Gtk::EntryCompletion::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GtkEntryCompletion * Gtk::EntryCompletion::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkEntryCompletion * Gtk::EntryCompletion::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GtkEntryCompletion * Gtk::EntryCompletion::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ insert_prefix()

void Gtk::EntryCompletion::insert_prefix | ( |  | ) |

Requests a prefix insertion.

## ◆ operator=()

EntryCompletion & Gtk::EntryCompletion::operator= | ( | EntryCompletion && | src | ) |
| noexcept

## ◆ property_cell_area()

Glib::PropertyProxy_ReadOnly< Glib::RefPtr< CellArea > > Gtk::EntryCompletion::property_cell_area | ( |  | ) | const

The `Gtk::CellArea` used to layout cell renderers in the treeview column.

If no area is specified when creating the entry completion with Gtk::EntryCompletion::new_with_area(), a horizontally oriented Gtk::CellAreaBox will be used.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_inline_completion() [1/2]

Glib::PropertyProxy< bool > Gtk::EntryCompletion::property_inline_completion | ( |  | ) |

Determines whether the common prefix of the possible completions should be inserted automatically in the entry.

Note that this requires text-column to be set, even if you are using a custom match function.

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_inline_completion() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::EntryCompletion::property_inline_completion | ( |  | ) | const

Determines whether the common prefix of the possible completions should be inserted automatically in the entry.

Note that this requires text-column to be set, even if you are using a custom match function.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_inline_selection() [1/2]

Glib::PropertyProxy< bool > Gtk::EntryCompletion::property_inline_selection | ( |  | ) |

Determines whether the possible completions on the popup will appear in the entry as you navigate through them.

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_inline_selection() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::EntryCompletion::property_inline_selection | ( |  | ) | const

Determines whether the possible completions on the popup will appear in the entry as you navigate through them.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_minimum_key_length() [1/2]

Glib::PropertyProxy< int > Gtk::EntryCompletion::property_minimum_key_length | ( |  | ) |

Minimum length of the search key in order to look up matches.

Default value: 1

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_minimum_key_length() [2/2]

Glib::PropertyProxy_ReadOnly< int > Gtk::EntryCompletion::property_minimum_key_length | ( |  | ) | const

Minimum length of the search key in order to look up matches.

Default value: 1

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_model() [1/2]

Glib::PropertyProxy< Glib::RefPtr< Gtk::TreeModel > > Gtk::EntryCompletion::property_model | ( |  | ) |

The model to find matches in.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_model() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gtk::TreeModel > > Gtk::EntryCompletion::property_model | ( |  | ) | const

The model to find matches in.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_popup_completion() [1/2]

Glib::PropertyProxy< bool > Gtk::EntryCompletion::property_popup_completion | ( |  | ) |

Determines whether the possible completions should be shown in a popup window.

Default value: `true`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_popup_completion() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::EntryCompletion::property_popup_completion | ( |  | ) | const

Determines whether the possible completions should be shown in a popup window.

Default value: `true`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_popup_set_width() [1/2]

Glib::PropertyProxy< bool > Gtk::EntryCompletion::property_popup_set_width | ( |  | ) |

Determines whether the completions popup window will be resized to the width of the entry.

Default value: `true`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_popup_set_width() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::EntryCompletion::property_popup_set_width | ( |  | ) | const

Determines whether the completions popup window will be resized to the width of the entry.

Default value: `true`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_popup_single_match() [1/2]

Glib::PropertyProxy< bool > Gtk::EntryCompletion::property_popup_single_match | ( |  | ) |

Determines whether the completions popup window will shown for a single possible completion.

You probably want to set this to `false` if you are using property_inline_completion().

Default value: `true`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_popup_single_match() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::EntryCompletion::property_popup_single_match | ( |  | ) | const

Determines whether the completions popup window will shown for a single possible completion.

You probably want to set this to `false` if you are using property_inline_completion().

Default value: `true`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_text_column() [1/2]

Glib::PropertyProxy< int > Gtk::EntryCompletion::property_text_column | ( |  | ) |

The column of the model containing the strings.

Note that the strings must be UTF-8.

Default value: -1

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_text_column() [2/2]

Glib::PropertyProxy_ReadOnly< int > Gtk::EntryCompletion::property_text_column | ( |  | ) | const

The column of the model containing the strings.

Note that the strings must be UTF-8.

Default value: -1

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ set_inline_completion()

void Gtk::EntryCompletion::set_inline_completion | ( | bool | inline_completion = `true` | ) |

Sets whether the common prefix of the possible completions should be automatically inserted in the entry.

Parameters

  inline_completion | `true` to do inline completion.

## ◆ set_inline_selection()

void Gtk::EntryCompletion::set_inline_selection | ( | bool | inline_selection = `true` | ) |

Sets whether it is possible to cycle through the possible completions inside the entry.

Parameters

  inline_selection | `true` to do inline selection.

## ◆ set_match_func()

void Gtk::EntryCompletion::set_match_func | ( | const SlotMatch & | slot | ) |

## ◆ set_minimum_key_length()

void Gtk::EntryCompletion::set_minimum_key_length | ( | int | length | ) |

Requires the length of the search key for completion to be at least length.

This is useful for long lists, where completing using a small key takes a lot of time and will come up with meaningless results anyway (ie, a too large dataset).

Parameters

  length | The minimum length of the key in order to start completing.

## ◆ set_model()

void Gtk::EntryCompletion::set_model | ( | const Glib::RefPtr< TreeModel > & | model | ) |

Sets the model for a Gtk::EntryCompletion.

If completion already has a model set, it will remove it before setting the new model. Use unset_model() to unset the old model.

Since gtkmm 2.4:

Parameters

  model | The `Gtk::TreeModel`.

## ◆ set_popup_completion()

void Gtk::EntryCompletion::set_popup_completion | ( | bool | popup_completion = `true` | ) |

Sets whether the completions should be presented in a popup window.

Parameters

  popup_completion | `true` to do popup completion.

## ◆ set_popup_set_width()

void Gtk::EntryCompletion::set_popup_set_width | ( | bool | popup_set_width = `true` | ) |

Sets whether the completion popup window will be resized to be the same width as the entry.

Parameters

  popup_set_width | `true` to make the width of the popup the same as the entry.

## ◆ set_popup_single_match()

void Gtk::EntryCompletion::set_popup_single_match | ( | bool | popup_single_match = `true` | ) |

Sets whether the completion popup window will appear even if there is only a single match.

You may want to set this to `false` if you are using property_inline_completion().

Parameters

  popup_single_match | `true` if the popup should appear even for a single match.

## ◆ set_text_column() [1/2]

void Gtk::EntryCompletion::set_text_column | ( | const TreeModelColumnBase & | column | ) |

Convenience function for setting up the most used case of this code: a completion list with just strings.

This function will set up completion to have a list displaying all (and just) strings in the completion list, and to get those strings from column in the model of completion.

This functions creates and adds a `Gtk::CellRendererText` for the selected column. If you need to set the text column, but don't want the cell renderer, use Glib::object_set() to set the property_text_column() property directly.

Parameters

  column | The column in the model of completion to get strings from.

## ◆ set_text_column() [2/2]

void Gtk::EntryCompletion::set_text_column | ( | int | column | ) |

Convenience function for setting up the most used case of this code: a completion list with just strings.

This function will set up completion to have a list displaying all (and just) strings in the completion list, and to get those strings from column in the model of completion.

This functions creates and adds a `Gtk::CellRendererText` for the selected column. If you need to set the text column, but don't want the cell renderer, use Glib::object_set() to set the property_text_column() property directly.

Parameters

  column | The column in the model of completion to get strings from.

## ◆ signal_cursor_on_match()

Glib::SignalProxy< bool(const TreeModel::iterator &)> Gtk::EntryCompletion::signal_cursor_on_match | ( |  | ) |

Emitted when a match from the cursor is on a match of the list.

The default behaviour is to replace the contents of the entry with the contents of the text column in the row pointed to by iter.

Parameters

  model | The TreeModel containing the matches
  iter | A TreeModel::iterator positioned at the selected match

Returns
  true if the signal has been handled

Prototype:
  `bool on_cursor_on_match(const TreeModel::iterator& iter)`

Since gtkmm 2.12:

## ◆ signal_insert_prefix()

Glib::SignalProxy< bool(const Glib::ustring &)> Gtk::EntryCompletion::signal_insert_prefix | ( |  | ) |

Slot Prototype:
  `bool on_my_insert_prefix(const Glib::ustring& prefix)`

Flags: Run Last

Emitted when the inline autocompletion is triggered.

The default behaviour is to make the entry display the whole prefix and select the newly inserted part.

Applications may connect to this signal in order to insert only a smaller part of the prefix into the entry - e.g. the entry used in the `Gtk::FileChooser` inserts only the part of the prefix up to the next '/'.

Parameters

  prefix | The common prefix of all possible completions.

Returns
  `true` if the signal has been handled.

## ◆ signal_match_selected()

Glib::SignalProxy< bool(const TreeModel::iterator &)> Gtk::EntryCompletion::signal_match_selected | ( |  | ) |

Emitted when a match from the list is selected.

The default behaviour is to replace the contents of the entry with the contents of the text column in the row pointed to by iter.

It is necessary to connect your signal handler before the default one, which would otherwise return `true`, a value which signifies that the signal has been handled, thus preventing any other handler from being invoked.

To do this, pass `false` to this signal proxy's `connect()` method. For example: `completion->signal_match_selected().connect(sigc::mem_fun(* this, & YourClass::on_completion_match_selected), false);`

Parameters

  model | The TreeModel containing the matches
  iter | A TreeModel::iterator positioned at the selected match

Returns
  true if the signal has been handled

Prototype:
  `bool on_match_selected(const TreeModel::iterator& iter)`

## ◆ signal_no_matches()

Glib::SignalProxy< void()> Gtk::EntryCompletion::signal_no_matches | ( |  | ) |

Slot Prototype:
  `void on_my_no_matches()`

Flags: Run Last

Emitted when the filter model has zero number of rows in completion_complete method.

In other words when `Gtk::EntryCompletion` is out of suggestions.

## ◆ unset_model()

void Gtk::EntryCompletion::unset_model | ( |  | ) |

Remove the model from the EntryCompletion.

See also
  set_model().

Since gtkmm 2.16:

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gtk::EntryCompletion > wrap | ( | GtkEntryCompletion * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.